# ConstrainedControl
[![Build Status](https://github.com/janbruedigam/ConstrainedControl.jl/workflows/CI/badge.svg)](https://github.com/janbruedigam/ConstrainedControl.jl/actions?query=workflow%3ACI)
[![codecov](https://codecov.io/gh/janbruedigam/ConstrainedControl.jl/branch/master/graph/badge.svg)](https://codecov.io/gh/janbruedigam/ConstrainedControl.jl)

**ConstrainedControl** is an experimental implementation of control methods for mechanical systems described in maximal coordinates. The package is built on top of the dynamics simulation ConstrainedDynamics. 

At the moment, the code is not yet documented, but the provided examples should help with getting started with the package. 

## Related Packages
* [ConstrainedDynamics](https://github.com/JuliaRobotics/ConstrainedDynamics.jl): Dynamics simulation in maximal coordinates
* [ConstrainedDynamicsVis](https://github.com/janbruedigam/ConstrainedDynamicsVis.jl): A package built on top of ConstrainedDynamics and MeshCat for visualization of simulations

## Related Publications
[Linear-Time Variational Integrators in Maximal Coordinates](https://arxiv.org/abs/2002.11245) (accepted to WAFR 2020) [Presentation](https://www.youtube.com/watch?v=kI5qBccGKfU)

[Linear-Quadratic Optimal Control in Maximal Coordinates](https://arxiv.org/abs/2010.05886) (accepted to ICRA 2021)

[Linear-Time Contact and Friction Dynamics in Maximal Coordinates using Variational Integrators](https://arxiv.org/abs/2109.07262)
